<!-- -*- mode: markdown; mode: flyspell -*- -->
# bash-base Changelog

## [0.4.37] - 2020-03-10
### Added
+ bb_string_trim_unicode
+ bb_string_trim_custom

## [0.4.36] - 2020-03-10
### Added
+ bb_array_insert
+ bb_string_trim
### Changed
* renamed bb_array_contains_index to bb_array_contains_key

## [0.4.35] - 2020-03-09
### Changed
* bb_var_want_array and _dict: fixed bb_msg call (#7)

## [0.4.34] - 2019-11-24
### Changed
* bb_array_concat now works with empty addon-array

## [0.4.33] - 2019-11-22
### Added
+ bb_array_is_sparse
+ bb_array_compact
+ bb_array_unsparse

## [0.4.32] - 2019-11-19
### Added
+ bb_msg_iterator
+ bb_msg_stacktrace
### Changed
* fix return values of bb_var_is functions
* make bb_var_assert_ print much more info

## [0.4.31] - 2019-11-19
### Changed
* cleaner API for bb_array_join_by

## [0.4.30] - 2019-11-18
### Changed
* bb_load_lib: better error handling
* internal errors: remove duplicate FUNCNAME from bb_ierr calls

## [0.4.29] - 2019-11-18
### Added
+ bb_is_callable
+ bb_var_type
+ bb_var_is_string, bb_var_is_array, bb_var_is_dict
+ bb_var_assert_string, bb_var_assert_array, bb_var_assert_dict
+ bb_var_assert_callable
+ bb_var_configure_want
+ bb_var_want_string, bb_var_want_array, bb_var_want_dict
+ bb_var_name_validate
+ bb_array_join_by_direct
+ bb_array_map_i and bb_array_map_k
+ bb_array_filter_i and bb_array_filter_k
+ bb_array_iter_i and bb_array_iter_k
+ bb_array_fold_left_i bb_array_fold_left_k
+ bb_array_fold_right_i bb_array_fold_right_k
### Changed
* bb_fatal now prints calling functions name
* bb_ierr now prints calling functions name itself
* bb_array_join_by now takes indirect array
* bb_array_fold_left and bb_array_fold_right got simpler API
### Deprecated
- bb_validate_vn

## [0.4.28] - 2019-11-15
### Added
+ bb_array_contains_index
+ bb_array_get
### Changed
* API change: bb_array_contains_value now returns 10 if not found

## [0.4.27] - 2019-11-15
### Added
+ bb_array_add and bb_array_concat
+ bb_array_set and bb_array_clear

## [0.4.26] - 2019-11-14
### Added
+ bb_var_type
+ bb_var_is_string, bb_var_is_array and bb_var_is_dict
+ bb_array_length and bb_array_is_empty
+ bb_string_split_regex and bb_string_split_regex_full
### Changed
* fix return values for map/iter/map2/filter/fold_right/fold_left
* use FUNCNAME[0] for fun names in error messages
* bb_string_split now accepts limit argument

## [0.4.25] - 2019-11-11
### #Added
+ bb_string_split

## [0.4.24] - 2019-11-10
### Added
+ bb_dict_keys
### Changed
* fixed error handling in bb_array_join_by

## [0.4.23] - 2019-11-08
### Added
+ bb_string_quote

## [0.4.22] - 2019-10-23
### Added
+ bb_funs_defined
+ new msg levels 8,9: debug2, debug3
### Changed
* debug messages now use debug3

## [0.4.21] - 2019-10-06
### Changed
* fixed bb_char_transliteration username charset

## [0.4.20] - 2019-10-06
### Added
+ bb_char_transliteration
+ bb_string_transliteration

## [0.4.19] - 2019-09-28
### Changed
* bb_msg now uses printf instead of echo
* bb_array_iter API change: now provides index

## [0.4.18] - 2019-09-28
### Added
+ bb_array_unique
### Changed
* bb_array_lenght: fixed arg checking

## [0.4.17] - 2019-09-26
### Changed
* bb_array_copy_without_vals: fixed return code
* bb_array_iter, map, map2, fold_* calls now return callback fails

## [0.4.16] - 2019-09-09
### Changed
* bb_msg_from_stdin got configurable prefix

## [0.4.15] - 2019-09-06
### Added
+ bb_msg_from_stdin

## [0.4.14] - 2019-08-12
### Added
+ bb_lock_aquire
+ bb_lock_release

## [0.4.13] - 2019-07-25
### Changed
* bb_validate_* functions stay quiet if caller-name is empty

## [0.4.12] - 2019-07-24
### Added
+ bb_validate_[u]int
+ bb_validate_regex

## [0.4.11] - 2019-07-17
### Changed
+ use bb_hex_validate in own code
+ API docu cleanup

## [0.4.10] - 2019-07-15
### Added
+ bb_hex_validate

## [0.4.9] - 2019-07-13
### Added
+ bb_array_copy_without_vals
+ bb_array_remove_vals
+ bb_hex_* functions

## [0.4.8] - 2019-06-10
### Added
+ bb_array_map2
+ bb_string_compare
+ bb_array_contains_value
### Changed
* bb_executables_in_path: fix bug with absolute paths
* cleanup example.sh
* code cleanup to satisfy new shellcheck version
* fixed extra args bug in bb_array_filter

## [0.4.7] - 2019-05-11
### Added
+ bb_array_compare
+ bb_array_fold_left and right
+ bb_array_reverse
### Changed
* fix typo in bb_executables_in_path and make it log less
* regress now compares arrays correct
* regress now adds dirt to destination arrays  before using them
* fixed array funs to clean destination before using it
* bb_array_join now works for join strings with more than one char

## [0.4.6] - 2019-05-10
### Changed
* make timestamps more readable

## [0.4.5] - 2019-04-27
### Changed
* bb_msg: fix wrong args for stack traces in file mode
* bb_msg: make notrace default as said in API docu

## [0.4.4] - 2019-04-24
### Changed
* fixed bb_msg_del_target

## [0.4.3] - 2019-04-24
### Changed
* renamed bb_msg_level_of_int to bb_msg_levelname_of_string
* fixed bb_msg

## [0.4.2] - 2019-04-24
### Changed
* extra check in bb_log if LOG_FILE is empty

## [0.4.1] - 2019-04-23
### Changed
* typo in bb_log

## [0.4] - 2019-04-23
### Add
+ new message tools
+ array tools
+ regress tests
+ error handling (e.g. ierr)
+ autogenerated API docu
### Changed
* enhanced error code schema
* multiple ways to load libraries
* deprecate old log functions
* make all functions use new message tools

## [0.3.9] - 2019-01-14
### Add
+ add bb_finalize

## [0.3.8] - 2019-01-11
### Changed
* bb_register_exit_hook now takes 1 or 2 args
* Makefile cleanup

## [0.3.7] - 2018-11-10
### Changed
* bb_require_libs: error handling uses return values instead of bb_fatal

## [0.3.6] - 2018-11-09
### Changed
* removed another call of deprecated function

## [0.3.5] - 2018-11-08
### Changed
* bb_require_libs now accepts local paths starting with './' and '../'
* stopped using deprecated functions in own code

## [0.3.4] - 2018-11-08
### Changed
* bb_require_libs now accepts local paths starting with './'
* non bb_ funs emit a deprecation warning

## [0.3.3] - 2018-10-17
### Changed
* bb_quit now accepts optional log msg

## [0.3.2] - 2018-10-08
### Added
+ added bb_exec

## [0.3.1] - 2018-09-26
### Added
+ added bb_logf

## [0.3.0] - 2018-04-11
### Added
+ hook function to be run at program exit can be (un)registered

### Changed
* prefixed `log`, `log_debug` and `fatal` with `bb_`
* traps are installed by default

### Removed
- `bb_traps_setup` and `bb_traps_disable` now just emit deprecated warning

## [0.2.5] - 2018-03-15
### Changed
* `bb_require_libs` supports absolute paths and search now is like docu says

## [0.2.4] - 2018-01-16
### Changed
* failures when loading bash-base in examples and docu now go to stderr

## [0.2.3] - 2018-01-16
### Changed
* fixed `bb_require_libs`

## [0.2.2] - 2018-01-16
### Changed
* smarter lib load paths

## [0.2.1] - 2018-01-16
### Added
+ `bb_require_libs`

### Removed
- Subdir in /usr/libexec

## [0.2] - 2018-01-16
### Added
+ First release

<!--  LocalWords:  Changelog stacktrace charset bb msg vn concat
 -->
